'Compilable Example:
#Compile Exe "gbcalendar.exe"
#Dim All
'#Debug Error On
'#Debug Display On
%Unicode=1
#Include "win32api.inc"

#Resource Icon logo "images\gbcalendar.ico"

$Ver = "2.1"
$DayList = "S   M   T   W   T   F   S"

Enum Equates Singular
   IDC_Graphic = 500
   IDM_Sep
   IDM_Exit
   IDM_TextColor
   IDM_TodayColor
   IDM_FontName
   IDM_ThreeMonths
   IDM_GoToToday
   IDM_White
   IDM_Black
   IDM_Help
   IDM_HideShort
   IDM_BestColorGuess
   IDM_Footer
   IDM_OnTop
End Enum

Type CustomColors
   c(15) As Long
End Type

Global hDlg,hGraphic,hFontD,hFontT,hFontM,ghHook As Dword
Global hBMPTemp,hBMPDesk,hContext As Dword, Footer,DragInWork As Long
Global wDesk,hDesk, Month, Year, Day, Months, Transparency,OnTop As Long
Global wMax,hMax,TextColor,TodayColor As Long, FontName As WStringZ * %Max_Path
Global CustomColorList As CustomColors, TheDate, tempDate As IPowerTime
Global hBitsDesk As String, OldProc As Long

Function PBMain () As Long
   Dialog New Pixels, 0, " ",300,500,250,250, %WS_Popup, %WS_Ex_Layered To hDlg
   Dialog Set Icon hDlg, "logo"
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local x,y As Long, pt As Point, temp$
   Select Case Cb.Msg
      Case %WM_InitDialog
         TheDate = Class "PowerTime"
         tempDate = Class "PowerTime"
         settings_ini "get"
         SetLayeredWindowAttributes(hDlg, %Green, Transparency, %LWA_ALPHA Or %LWA_Colorkey)
         ManageOnTop
         Dialog Set Size hDlg, 250, IIf(Months=1, 250, 620)
         CreateContextMenus
         CreateGraphicControl
         CreateFonts
         Control Set Size hDlg, %IDC_Graphic, 250, IIf(Months=1, 250, 620)
         RefreshDesktopMemoryBitmap
         CopyUnderLyingImageToGraphicControl
         SetMenusAndToolbar
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Exit      : Dialog End hDlg
            Case %IDM_TodayColor
               x = SelectColor(TodayColor)
               If x <> TodayColor Then TodayColor = x : CopyUnderlyingImageToGraphicControl
            Case %IDM_White
               TextColor = %White
               CopyUnderlyingImageToGraphicControl
            Case %IDM_Black
               TextColor = %Black
               CopyUnderlyingImageToGraphicControl
            Case %IDM_TextColor
               x = SelectColor(TextColor)
               If x <> TextColor Then TextColor = x : CopyUnderlyingImageToGraphicControl
            Case %IDM_FontName
               temp$ = SelectMainFont
               If temp$ <> FontName Then
                  FontName = temp$
                  CreateFonts
                  CopyUnderlyingImageToGraphicControl
               End If
            Case %IDM_ThreeMonths
               Months = IIf(Months=1,3,1)
               Dialog Set Size hDlg, 250, IIf(Months=1, 250, 620)
               Control Set Size hDlg, %IDC_Graphic, 250, IIf(Months=1, 250, 620)
               CopyUnderLyingImageToGraphicControl
               SetMenusAndToolbar
            Case %IDM_BestColorGuess
               GuessColor
               CopyUnderLyingImageToGraphicControl
            Case %IDM_GoToToday
               Year = Val(Right$(Date$,4))
               Month = Val(Left$(Date$,2))
               CopyUnderLyingImageToGraphicControl
            Case %IDM_Help
               temp$ = "http://www.garybeene.com/sw/gbcalendar.htm"
               x = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_HideShort
               Dialog Hide hDlg : Sleep(1000*5) : Dialog Normalize hDlg
            Case %IDM_OnTop
               OnTop Xor= 1
               SetMenusAndToolbar
               ManageOnTop
            Case %IDM_Footer
               Footer Xor= 1
               SetMenusAndToolbar
               CopyUnderLyingImageToGraphicControl
         End Select
      Case %WM_MouseWheel
         Select Case Hi(Integer,Cb.WParam)    'note the use of Integer
            Case > 0 : Transparency = Min (255, Transparency + 5)
            Case < 0 : Transparency = Max (0, Transparency - 5)
         End Select
         If Transparency = 255 Or Transparency = 0 Then Beep
         SetLayeredWindowAttributes(hDlg, %Green, Transparency, %LWA_ALPHA Or %LWA_Colorkey)
      Case %WM_Move
         If DragInWork Then
            DragInWork = 0
            RefreshDesktopMemoryBitmap
         End If
         CopyUnderLyingImageToGraphicControl
      Case %WM_ContextMenu
         pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)
         TrackPopupMenu hContext, %TPM_LeftAlign, pt.x, pt.y, 0, Cb.Hndl, ByVal 0
      Case %WM_LButtonUp
         DragInWork = 0
      Case %WM_LButtonDown, %WM_LButtonDblClk
         DraginWork = 1
         'if on buttons, change month
         x = Lo(Word,Cb.LParam)
         y = Hi(Word,Cb.LParam)
         If x > 225 And y < 25 Then
            Incr Month
            If Month > 12 Then Incr Year : Month = 1
         End If
         If x < 25 And y < 25 Then
            Decr Month
            If Month < 1 Then Decr Year : Month = 12
         End If
         'update image
         'Dialog Show State hDlg, %SW_Hide
         'RefreshDesktopMemoryBitmap
         'Dialog Show State hDlg, %SW_Show
         CopyUnderLyingImageToGraphicControl
         'drag since no caption
         SendMessage hDlg, %WM_NCLButtonDown, %HTCaption, ByVal %Null
      Case %WM_Destroy
         settings_ini "save"
   End Select
End Function

Sub Settings_INI(Task$)
   Local x,y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "250", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "200", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "Month", "1", temp, %Max_Path, INIFileName:  Month = Val(temp)
      Getprivateprofilestring "All", "Year", "2014", temp, %Max_Path, INIFileName:  Year = Val(temp)
      Getprivateprofilestring "All", "Day", "1", temp, %Max_Path, INIFileName:  Day = Val(temp)
      Getprivateprofilestring "All", "Months", "1", temp, %Max_Path, INIFileName:  Months = Val(temp)
      Getprivateprofilestring "All", "Transparency", "255", temp, %Max_Path, INIFileName:  Transparency = Val(temp)
      Getprivateprofilestring "All", "TextColor", Str$(%rgb_DarkRed), temp, %Max_Path, INIFileName:  TextColor = Val(temp)
      Getprivateprofilestring "All", "TodayColor", Str$(%Red), temp, %Max_Path, INIFileName:  TodayColor = Val(temp)
      Getprivateprofilestring "All", "wMax", "250", temp, %Max_Path, INIFileName:  wMax = Val(temp)
      Getprivateprofilestring "All", "hMax", "200", temp, %Max_Path, INIFileName:  hMax = Val(temp)
      Getprivateprofilestring "All", "OnTop", "1", temp, %Max_Path, INIFileName:  OnTop = Val(temp)
      Getprivateprofilestring "All", "Footer", "1", temp, %Max_Path, INIFileName:  Footer = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "Month", Str$(Month), INIFileName
      WritePrivateProfileString "All", "Year", Str$(Year), INIFileName
      WritePrivateProfileString "All", "Day", Str$(Day), INIFileName
      WritePrivateProfileString "All", "Months", Str$(Months), INIFileName
      WritePrivateProfileString "All", "Transparency", Str$(Transparency), INIFileName
      WritePrivateProfileString "All", "TextColor", Str$(TextColor), INIFileName
      WritePrivateProfileString "All", "TodayColor", Str$(TodayColor), INIFileName
      WritePrivateProfileString "All", "wMax", Str$(wMax), INIFileName
      WritePrivateProfileString "All", "hMax", Str$(hMax), INIFileName
      WritePrivateProfileString "All", "OnTop", Str$(OnTop), INIFileName
      WritePrivateProfileString "All", "Footer", Str$(Footer), INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub

Sub SetMenusAndToolbar
    Menu Set State hContext, ByCmd %IDM_ThreeMonths, IIf(Months=3,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hContext, ByCmd %IDM_OnTop, OnTop * %MFS_Checked Or %MFS_Enabled
    Menu Set State hContext, ByCmd %IDM_Footer, Footer * %MFS_Checked Or %MFS_Enabled
End Sub

Sub CreateContextMenus
   Menu New PopUp To hContext
   Menu Add String, hContext, "Exit",  %IDM_Exit,  %MF_Enabled
   Menu Add String, hContext, "Hide 5 Seconds",  %IDM_HideShort,  %MF_Enabled
   Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Three Month Display",  %IDM_ThreeMonths,  %MF_Enabled
   Menu Add String, hContext, "On Top",  %IDM_OnTop,  %MF_Enabled
   Menu Add String, hContext, "Footer",  %IDM_Footer,  %MF_Enabled
   Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "White Text Color",  %IDM_White,  %MF_Enabled
   Menu Add String, hContext, "Black Text Color",  %IDM_Black,  %MF_Enabled
   Menu Add String, hContext, "Best Text Color",  %IDM_BestColorGuess,  %MF_Enabled
   Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Select Text Color",  %IDM_TextColor,  %MF_Enabled
   Menu Add String, hContext, "Select Today Color",  %IDM_TodayColor,  %MF_Enabled
   Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Select Font Name",  %IDM_FontName,  %MF_Enabled
   Menu Add String, hContext, "Go To Today",  %IDM_GoToToday,  %MF_Enabled
   Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Online Help",  %IDM_Help,  %MF_Enabled
End Sub

Sub CreateGraphicControl
   Control Add Graphic, hDlg, %IDC_Graphic, "", 0,0, wMax,hMax
   Control Handle hDlg, %IDC_Graphic To hGraphic
   OldProc = SetWindowLong(hGraphic, %GWL_WndProc, CodePtr(NewGraphicProc))  'subclass
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub

Function NewGraphicProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case Msg
      Case %WM_MouseWheel
         Select Case Hi(Integer,WParam)    'note the use of Integer
            Case > 0 : Transparency = Min (255, Transparency + 20)
            Case < 0 : Transparency = Max (0, Transparency - 20)
         End Select
         If Transparency = 255 Or Transparency = 0 Then Beep
         SetLayeredWindowAttributes(hDlg, %Green, Transparency, %LWA_ALPHA Or %LWA_Colorkey)
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateFonts
   Font New FontName,10,1 To hFontD   'day
   Font New FontName,14,1 To hFontT   'title
   Font New FontName,22,1 To hFontM   'month
End Sub

Sub ManageOnTop
   If OnTop Then
      SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE)  'on Top
   Else
      SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE) 'not on Top
   End If
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Function SelectMainFont() As String
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, 10,0, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then Function = fName Else Function = FontName
End Function

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 190
        If UCase$(szTemp) = "BUTTON" Then
           Select Case @cst.hMenu
              Case %IdOk   :   @cst.x=@cst.x - 180
              Case %IdCancel : @cst.x=@cst.x - 180
           End Select
        Else
           If @cst.x > 160 Then @cst.x = @cst.x + 1000
        End If
    End If
End Function

Sub RefreshDesktopMemoryBitmap
   Local hBMPDC,hDeskTopDC As Dword
    wDesk = GetSystemMetrics( %SM_CXVIRTUALSCREEN )    '<--- handles dual monitors of same size
    hDesk = GetSystemMetrics( %SM_CYVIRTUALSCREEN )    '<--- handles dual monitors of same size
   Graphic Bitmap New wDesk, hDesk To hBMPDesk
   Graphic Attach hBMPDesk, 0
   Graphic Get DC To hBMPDC
   hDeskTopDC = GetDC(%Null)
   BitBlt hBMPDC,0,0,wDesk,hDesk,hDeskTopDC,0,0, %SRCCopy
   ReleaseDC(%Null,hDeskTopDC)
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub

Sub CopyUnderlyingImageToGraphicControl
   Local i,j,k,w,h,x,y,Days,DayOfWeek,DayCount,iTop,ThisMonth As Long
   Local iReturn, dYears,dMonths,dDays As Long, temp$, hTemp$, hBMP$
   Dialog Get Size hDlg To w,h
   Dialog Get Loc hDlg To x,y

   'create temp copy of underlying area of DeskTop
   Graphic Bitmap New w,h To hBMPTemp
   Graphic Attach hBMPTemp, 0
   Graphic Copy hBMPDesk, 0, (x,y)-(x+w-1,y+h-1) To (0,0)
   Graphic Get Bits To hTemp$

   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Color TextColor, -2
   Graphic Width 3

   'underlying image
   Graphic Copy hBMPDesk, 0, (x,y)-(x+w-1,y+h-1) To (0,0)

   'arrows
   Graphic Line (10,15)-(20,5), TextColor
   Graphic Line (10,15)-(20,25), TextColor
   Graphic Line (20,5)-(20,25), TextColor
   Graphic Paint Border (15,15), TextColor, TextColor

   Graphic Line (wMax-10,15)-(wMax-20,5), TextColor
   Graphic Line (wMax-10,15)-(wMax-20,25), TextColor
   Graphic Line (wMax-20,5)-(wMax-20,25), TextColor
   Graphic Paint Border (wMax-15,15), TextColor, TextColor

   'Month, Week, Day text
   For k = 0 To Months-1
      iTop = k * 200
      'Month
      ThisMonth = IIf((Month+k)>12, (Month+k) Mod 12, Month+k)
      Graphic Set Font hFontM
      temp$ = MonthName$(ThisMonth)
      x = (wMax-Graphic(Text.Size.X,temp$))/2
      Graphic Set Pos (x,iTop)
      Graphic Print temp$

      'Year
      Graphic Set Font hFontT
      Graphic Set Pos (wMax -65,iTop+30)
      Graphic Print IIf(month+k > 12, Year+1, Year)

      'Days of the Week (Title)
      Graphic Set Font hFontT
      x = (wMax-Graphic(Text.Size.X,$DayList))/2
      Graphic Set Pos (x,55 + k * 200)
      Graphic Print $DayList

      Graphic Set Font hFontD
      'Footer
      If Footer And (k = Months-1) Then
         temp$ = "gbCalendar   v" + $ver
         x = (wMax-Graphic(Text.Size.X,temp$))/2
         Graphic Set Pos (x,IIf(Months=1, 210, 600))
         Graphic Print temp$
      End If

      'Days of the Month
      tempDate.Today
      DayCount  = 0
      TheDate.NewDate(Year,ThisMonth,1)   'set time 1st day of month/year setting
      Days = TheDate.DaysInMonth
      DayOfWeek = TheDate.DayOfWeek
      For i = 0 To 5  'weeks
         For j = 1 To 7
            If (i*7+j) < (DayOfWeek+1) Then Iterate For
            Incr DayCount
            If DayCount > Days Then Exit, Exit
            x = j*33-20
            y = 60+(i+1)*20 + k * 200
            Graphic Set Pos (x,y)
            Graphic Print i*7 + j - DayOfWeek
            TheDate.NewDate Year, ThisMonth, DayCount
            TheDate.DateDiff tempDate, iReturn, dYears, dMonths,dDays
            If iReturn = 0 Then Graphic Ellipse (x,y-5)-(x+25,y+20),TodayColor
         Next j
      Next j
   Next k

   'comparison to Green
   Graphic Get Bits To hBMP$
   Dim A(Len(hBMP$)/4-3) As Long At StrPtr(hBMP$) + 8
   Dim B(Len(hTemp$)/4-3) As Long At StrPtr(hTemp$) + 8
   For x = 0 To UBound(A)
      If B(x) = A(x) Then A(x) = %Green
   Next x
   Graphic Set Bits hBMP$

   'Redraw
   Graphic ReDraw

   SetLayeredWindowAttributes(hDlg, %Green, Transparency, %LWA_ALPHA Or %LWA_Colorkey)
End Sub

Sub GuessColor
   Local w,h,x,y As Long, hBMP$, hBMPTemp As Dword
   Local avgR, avgG, avgB As Long

   'create temp copy of underlying area of DeskTop
   Dialog Get Size hDlg To w,h
   Dialog Get Loc hDlg To x,y
   Graphic Bitmap New w,h To hBMPTemp
   Graphic Attach hBMPTemp, 0
   Graphic Copy hBMPDesk, 0, (x,y)-(x+w-1,y+h-1) To (0,0)
   Graphic Get Bits To hBMP$

   'get average
   Dim A(Len(hBMP$)/4-3) As Long At StrPtr(hBMP$) + 8
   For x = 0 To UBound(A)        'A() values are BGR 0-R-G-B in memory
      avgB += A(x) Mod 256
      avgG += (A(x)\256) Mod 256
      avgR += (A(x)\256\256) Mod 256
   Next x
   TextColor = RGB(avgR/x*.299, avgG/x*-.587, avgB/x*0.114)
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub
